"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const initActionTypeNamespace = (obj, delimiter, objName, parentName) => {
    let actionTypeNamespace = "";
    if (parentName !== undefined && parentName !== "") {
        actionTypeNamespace = parentName + delimiter;
    }
    if (objName !== undefined) {
        actionTypeNamespace = actionTypeNamespace + objName;
    }
    for (const propertyName in obj) {
        if (obj.hasOwnProperty(propertyName)) {
            const propertyValue = obj[propertyName];
            if (typeof propertyValue === "string") {
                obj[propertyName] = actionTypeNamespace + delimiter + propertyName;
            }
            else {
                initActionTypeNamespace(propertyValue, delimiter, propertyName, actionTypeNamespace);
            }
        }
    }
};
const createReduxActionTypes = (actionTypesObject, delimiter = "/", namespace) => {
    const ret = JSON.parse(JSON.stringify(actionTypesObject));
    initActionTypeNamespace(ret, delimiter, namespace);
    return ret;
};
exports.default = createReduxActionTypes;
//# sourceMappingURL=createReduxActionTypes.js.map